'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var PropTypes = _interopDefault(require('prop-types'));
var styled = require('styled-components');
var styled__default = _interopDefault(styled);

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n    animation: ", " 3s linear infinite;\n  "]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n    animation: ", " 3s linear infinite;\n  "]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n    animation: ", " 3s linear infinite;\n  "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  display: block;\n  width: ", ";\n  height: ", ";\n  border-radius: 50%;\n  box-shadow: ", ";\n  ", "\n\n  &:before {\n    position: absolute;\n    content: '';\n    border-radius: 50%;\n    top: ", "\n    right: ", "\n    bottom: ", "\n    left: ", "\n    box-shadow: ", ";\n    ", "\n  }\n\n  &:after {\n    position: absolute;\n    content: '';\n    top: ", "\n    right: ", "\n    bottom: ", "\n    left: ", "\n    border-radius: 50%;\n    box-shadow: ", ";\n    ", "\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  from {\n    transform: rotate(0deg);\n  }\n\n  to {\n    transform: rotate(360deg);\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var rotate360 = styled.keyframes(_templateObject());
var Spinner = styled__default.div(_templateObject2(), function (props) {
  return "".concat(props.size, "px");
}, function (props) {
  return "".concat(props.size, "px");
}, function (props) {
  return props.layer1 ? props.layer1 : "0px ".concat(props.thickness, "px ").concat(props.thickness, "px ").concat(props.spread, "px indianred");
}, function (props) {
  return props.animation1;
}, function (props) {
  return "".concat(props.outerOffset, "px");
}, function (props) {
  return "".concat(props.outerOffset, "px");
}, function (props) {
  return "".concat(props.outerOffset, "px");
}, function (props) {
  return "".concat(props.outerOffset, "px");
}, function (props) {
  return props.layer2 ? props.layer2 : "0px ".concat(props.thickness, "px ").concat(props.thickness, "px ").concat(props.spread, "px gold");
}, function (props) {
  return props.animation2;
}, function (props) {
  return "".concat(props.innerOffset, "px");
}, function (props) {
  return "".concat(props.innerOffset, "px");
}, function (props) {
  return "".concat(props.innerOffset, "px");
}, function (props) {
  return "".concat(props.innerOffset, "px");
}, function (props) {
  return props.layer3 ? props.layer3 : "0px ".concat(props.thickness, "px ").concat(props.thickness, "px ").concat(props.spread, "px cornflowerblue");
}, function (props) {
  return props.animation3;
});
function Spinner3(props) {
  return React.createElement(Spinner, _extends({
    style: props.style
  }, props));
}
Spinner3.defaultProps = {
  size: 150,
  spread: 0,
  thickness: 1,
  innerOffset: 10,
  outerOffset: 5,
  animation1: styled.css(_templateObject3(), rotate360),
  animation2: styled.css(_templateObject4(), rotate360),
  animation3: styled.css(_templateObject5(), rotate360)
};
Spinner3.propTypes = {
  style: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  size: PropTypes.number,
  innerOffset: PropTypes.number,
  outerOffset: PropTypes.number,
  spread: PropTypes.number,
  thickness: PropTypes.number,
  layer1: PropTypes.string,
  layer2: PropTypes.string,
  layer3: PropTypes.string,
  animation1: PropTypes.string,
  animation2: PropTypes.string,
  animation3: PropTypes.string
};

module.exports = Spinner3;
